package de.accso.flexinale.application.services;

import de.accso.flexinale.application.Config;
import de.accso.flexinale.domain.dao.AbstractDao;
import de.accso.flexinale.domain.dao.KinoSaalDao;
import de.accso.flexinale.domain.dao.VorfuehrungDao;
import de.accso.flexinale.domain.model.Film;
import de.accso.flexinale.domain.model.KinoSaal;
import de.accso.flexinale.domain.model.Vorfuehrung;
import de.accso.flexinale.shared_kernel.Identifiable;
import jakarta.transaction.Transactional;
import org.apache.poi.ss.usermodel.Row;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.time.LocalDateTime;

@Transactional
public class VorfuehrungUploadService extends AbstractExcelDataUploadService<Vorfuehrung> {
    private static final Logger LOGGER = LoggerFactory.getLogger(VorfuehrungUploadService.class);

    private final KinoSaalDao kinoSaalDao;
    private final VorfuehrungDao vorfuehrungDao;

    private final Config config;

    public VorfuehrungUploadService(final VorfuehrungDao vorfuehrungDao, final KinoSaalDao kinoSaalDao, final Config config) {
        this.kinoSaalDao = kinoSaalDao;
        this.vorfuehrungDao = vorfuehrungDao;
        this.config = config;
    }

    @Override
    public AbstractDao<Vorfuehrung> getDao() {
        return vorfuehrungDao;
    }

    @Override
    public String getNameOfExcelDataType() {
        return Vorfuehrung.class.getSimpleName();
    }

    @Override
    public Vorfuehrung createDataFromExcelRow(final Row excelRow) {
        String vorfuehrungIdAsString = excelRow.getCell(0).getStringCellValue();

        // expects date/time in format like for example 2023-02-20T17:45
        LocalDateTime zeit = LocalDateTime.parse(excelRow.getCell(1).getStringCellValue());

        String filmIdAsString = excelRow.getCell(2).getStringCellValue();
        Film film = new Film(Identifiable.Id.of(filmIdAsString));
        String kinoSaalId = excelRow.getCell(3).getStringCellValue();
        KinoSaal kinoSaal = kinoSaalDao.findById(Identifiable.Id.of(kinoSaalId)).orElseThrow(IllegalStateException::new);

        Vorfuehrung vorfuehrung = new Vorfuehrung(Identifiable.Id.of(vorfuehrungIdAsString),
                new Vorfuehrung.Zeit(zeit), film, kinoSaal, config.getQuoteOnline());

        LOGGER.debug("New Vorfuehrung created: " + vorfuehrung);

        return vorfuehrung;
    }
}
